//---------------------------------------------------------------------------

#ifndef appMainH
#define appMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>

#include <windows.h>

typedef bool (__stdcall *MOUSEHOOKFCT)();
typedef DWORD (_stdcall *LASTINPUT)();
HINSTANCE DllHandle;
LASTINPUT GetLastInput;
MOUSEHOOKFCT InstHook; 
MOUSEHOOKFCT RemHook; 
//DWORD g_dwLastInputTick;

//---------------------------------------------------------------------------
/*
class app
{
public:
	app(AnsiString s)
	{
		idle_time=0;
		warned = false;
		closed = false;
		cl_msg_sent = false;
		int i=0;
		while(s.Pos("|"))
		{
			i++;
			AnsiString c = s.SubString(1,s.Pos("|")-1);
			switch(i)
			{
				case 1:
					name = c;
				break;
				case 2:
					proc_name = c;
				break;
				case 3:
					warn_time = StrToInt(c);
				break;
				case 4:
					close_time = StrToInt(c);
				break;
			}
			s = s.SubString(s.Pos("|")+1,s.Length());
		}
	}

	void check(Processes& proc)
	{
		unsigned long id = proc.id(proc_name);
		if(id==0) //    
		{
			idle_time = 0;
			closed = true;
			warned = true;
			cl_msg_sent = false;
			return;
		}
		closed = false;
		DWORD pidwin;
		HWND h = GetForegroundWindow();
		GetWindowThreadProcessId(h, &pidwin);
		if(pidwin==id) //   
			idle_time = (GetTickCount()-GetLastInput())/1000;
		else
			idle_time++;
		if(idle_time<warn_time) warned = false;
		if(warn_time>-1&&idle_time>=warn_time&&!warned&&!closed)
		{
			warned = true;
			LOG(" "+CurrUser()+"    "+name,warning);
			MessageBox(h,AnsiString(" "+name+"!").c_str(), "!", MB_ICONEXCLAMATION|MB_OK|MB_TOPMOST|MB_SYSTEMMODAL);
			return;
		}
		if(close_time>-1&&idle_time>=close_time&&!closed)
		{
//			closed = true;
			warned = true;
			if(!cl_msg_sent)
			{
				LOG(CurrUser()+"   .closed"+name,error);
				proc.close(proc_name);
				cl_msg_sent = true;
			}
			else
			{
				LOG(CurrUser()+"   .terminated"+name,error);
				proc.terminate(proc_name);
				closed = true;
			}
//			LOG(CurrUser()+"   "+name,error);
			MessageBox(h,AnsiString("   "+name+"!").c_str(), " !", MB_ICONEXCLAMATION|MB_OK|MB_TOPMOST|MB_SYSTEMMODAL);
			return;
		}
	}
	
	AnsiString name;
	AnsiString proc_name;
	int warn_time;
	int close_time;
	int idle_time;
	bool warned;
	bool cl_msg_sent;
	bool closed;
	
private:
};
*/
//---------------------------------------------------------------------------
class TFormMain : public TForm
{
__published:	// IDE-managed Components
	TTimer *Timer1;
	TLabel *Label1;
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations

	
public:		// User declarations
	__fastcall TFormMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormMain *FormMain;
//---------------------------------------------------------------------------
#endif
