//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "appMain.h"
#include <assert.h>
#include <registry.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormMain *FormMain;
//---------------------------------------------------------------------------

__fastcall TFormMain::TFormMain(TComponent* Owner)
	: TForm(Owner)
{
	DllHandle = LoadLibrary("dllTest2Dll.dll"); 
	assert(DllHandle);
	
	InstHook = reinterpret_cast<MOUSEHOOKFCT>(GetProcAddress(DllHandle, "_InstallHook")); 
	RemHook = reinterpret_cast<MOUSEHOOKFCT>(GetProcAddress(DllHandle, "_RemoveHook")); 
	GetLastInput = reinterpret_cast<LASTINPUT>(GetProcAddress(DllHandle, "_GetLastInput")); 
	assert(InstHook);
	assert(RemHook);
	assert(GetLastInput);
	InstHook();
}
//---------------------------------------------------------------------------

void __fastcall TFormMain::Timer1Timer(TObject *Sender)
{
	TRegistry* r = new TRegistry();
	r->RootKey = HKEY_CURRENT_USER;
	r->OpenKey("\\Control Panel\\Desktop",false);
	int t = StrToInt(r->ReadString("ScreenSaveTimeOut"));
	Label1->Caption  = "   "+IntToStr(t-(GetTickCount()-GetLastInput())/1000);
	delete r;
}

//---------------------------------------------------------------------------

void __fastcall TFormMain::FormClose(TObject *Sender, TCloseAction &Action)
{
	RemHook();
	FreeLibrary(DllHandle); 
}

//---------------------------------------------------------------------------







